ScriptName FS_TeleportPlayerToRef extends ActiveMagicEffect

; Properties ==================================================
ObjectReference Property DestinationRef Auto
{A marker for the teleport destination}
ImageSpaceModifier Property FadeToBlackImod Auto
ImageSpaceModifier Property FadeToBlackHoldImod Auto
ImageSpaceModifier Property FadeToBlackBackImod Auto

; Locals ======================================================
Bool CanFastTravel

; =============================================================
Event OnEffectStart(Actor akTarget, Actor akCaster)
	CanFastTravel = Game.IsFastTravelEnabled()

	FadeToBlackImod.Apply()
	Utility.wait(2.0)
	FadeToBlackImod.PopTo(FadeToBlackHoldImod)
	
	akCaster.MoveTo(DestinationRef, 0, 0, 0, true)

	; Allows fast travel inside an interior cell
	Game.EnableFastTravel()
	
	; Force game to calculate a fast travel route to bring followers along
	; Since you're already at your destination no time should pass
	Game.FastTravel(DestinationRef)

	; Re-disable fast travel if it was disabled before
	; Prevents MoveTo from re-enabling fast travel if it has been forced off
	If CanFastTravel == false
		Game.EnableFastTravel(false)
	EndIf

	FadeToBlackHoldImod.PopTo(FadeToBlackBackImod)
	FadeToBlackHoldImod.Remove()
EndEvent
